<template>
    <div class="query-container">
        <div class="query-headline"> Query MetaboSERV</div>
        <div class="query-section">
            <div class="query-sub-headline">1. Select studies</div>
            <div class="query-study-selection">
                <div class="query-all-studies">
                    <div class="query-sub-headline">All studies</div>
                    <div class="selection-box-all">
                        <div v-for="study in all_studies" :key="study.study_id" class="study-row" @click="addtoSelection(study)">
                            <div>{{ study.study_name }}</div>
                            <div style="display: flex; flex-wrap: wrap; flex-direction: row; gap: 4px;">
                                <div class="info-box" v-for="property in Object.keys(study).filter((key) => box_keys.includes(key) && study[key as keyof Object])" :style="{
                                    'background-color': getInfoboxColor(property, study[property as keyof Object]),
                                    'color': (property == 'study_type' ? '#fff' : '#000')
                                }">{{formatInfobox(property, study[property as keyof Object])}}</div> 
                            </div>
                        </div>
                        <span class="span-grid">Simply click on a study to add it to the selection.</span>
                    </div>
                    
                </div>
                <div class="query-selected-studies">
                    <div class="query-sub-headline">Selection</div>
                    <div class="selection-box">
                        <div v-for="study of query.query_studies" class="study-select-row">
                            {{ study.study_name }}
                            <Icon icon="mdi:cancel-bold" width="30" height="30" color="var(--color-primary)" class="icon" @click="query.query_studies?.splice(query.query_studies.indexOf(study), 1)"/>
                        </div>
                        <div v-if="!query.query_studies || query.query_studies.length == 0" style="text-align: center;">
                            Select some studies on the left!
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="query-section" v-if="query.query_studies?.length">
            <div class="query-sub-headline">2. Select metabolites to retrieve</div>
            <div class="query-metabolite-selection">
                <div class="query-metabolite-box">
                    <div class="query-metabolite-manage">
                        <span class="bold-centered">Which metabolites do you want to retrieve?</span>
                        <div><input type="checkbox" style="accent-color: var(--color-accent)" @change="deactivateOtherCheckboxes('checkbox_all')"
                            v-model="metabolite_checkboxes['checkbox_all' as keyof Object]" id="checkbox-all">&nbsp; All metabolites</div>
                        <div><input type="checkbox" style="accent-color: var(--color-accent)" @change="deactivateOtherCheckboxes('checkbox_ex')"
                            v-model="metabolite_checkboxes['checkbox_ex' as keyof Object]" id="checkbox-ex">&nbsp; Choose metabolites to exclude</div>
                        <div><input type="checkbox" style="accent-color: var(--color-accent)" @change="deactivateOtherCheckboxes('checkbox_sub')"
                            v-model="metabolite_checkboxes['checkbox_sub' as keyof Object]" id="checkbox-sub">&nbsp; Choose subset</div>
                    </div>
                    <div class="query-metabolite-all">
                        <b style="text-align: center">All metabolites</b>
                        <div class="metabolite-collection">
                            <div class="metabolite-entry" v-for="compound of Object.keys(query.query_compounds)" 
                            @mouseover="showMetaboliteInfo(compound)" @mouseleave="hideMetaboliteInfo()" @click="addToQueryCompounds(compound)">
                            {{ compound }}</div>
                        </div>
                    </div>
                    <div class="query-metabolite-info">
                        <div class="metabolite-info" v-if="metabolite_shown && Object.keys(metabolite_shown).length >= 1">
                            <span style="font-weight: bold;">{{ metabolite_shown['compound_id'] }}</span>
                            <span style="font-size: var(--fs-small); color: var(--dark)">{{ metabolite_shown['compound_iupac'] }}</span>
                            <span>{{ metabolite_shown['compound_name'] }}</span>
                            <span>{{ metabolite_shown['compound_formula']}}</span>
                            <span v-if="metabolite_shown['compound_synonyms']">Also known by <b>{{metabolite_shown['compound_synonyms']?.length}}</b> other synonyms.</span>
                            <span>&nbsp;</span>
                            <span v-if="metabolite_shown['taxonomy']" style="font-size: var(--fs-small); color: var(--color-head)">{{ metabolite_shown['taxonomy']['kingdom']}}</span>
                            <span v-if="metabolite_shown['taxonomy']" style="font-size: var(--fs-small); color: var(--color-primary)">{{ metabolite_shown['taxonomy']['superclass']}}</span>
                            <span v-if="metabolite_shown['taxonomy']" style="font-size: var(--fs-small); color: var(--color-secondary)">{{ metabolite_shown['taxonomy']['group']}}</span>
                        </div>
                        <div v-if="!metabolite_shown || Object.keys(metabolite_shown).length == 0">Hover over a metabolite to show additional information.</div>
                    </div>
                    <div class="query-metabolite-all">
                        <span class="span-grid" style="margin: 0 1rem;">Use the checkboxes on top to pick a new retrieval mode. Click metabolites on the left to add them to the selection.</span>
                        <b style="text-align: center" v-if="metabolite_checkboxes['checkbox_all']">All metabolites will be retrieved.</b>
                        <b style="text-align: center" v-if="metabolite_checkboxes['checkbox_sub']">Only this subset will be retrieved:</b>
                        <b style="text-align: center" v-if="metabolite_checkboxes['checkbox_ex']">These metabolites will NOT be retrieved:</b>
                        <div class="selection-box">
                            <div v-for="compound of query.query_compound_selection" class="study-select-row">
                                {{ compound }}
                                <Icon icon="mdi:cancel-bold" width="30" height="30" color="var(--color-primary)" class="icon" 
                                @click="query.query_compound_selection?.splice(query.query_compound_selection.indexOf(compound), 1)"/>
                            </div>
                        </div>
                        <span class="span-grid" style="margin: 0 1rem;" v-if="metabolite_checkboxes['checkbox_all']">
                            You have currently selected to retrieve all available metabolites.
                            However, if you decide to switch your method of retrieval (e.g. to 'choose subset'), this selection is maintained.
                        </span> 
                    </div>
                </div>
            </div>
        </div>
        <div class="query-section" v-if="query.query_studies?.length">
            <div class="query-sub-headline">3. Apply additional rules</div>
            <div class="query-metabolite-selection">
                <div class="rule-grid filter-grid" id="metabolite-filter-grid">
                        <div class="rule-item filter-grid-headline">
                            <b>Metabolite</b>
                            <b>Unit</b>
                            <b>Filter Type</b>
                            <b>Values</b>
                            <div style="width: 48px; height: 48px;"/>
                        </div>
                        <div v-for="rule of metabolite_filters" :key="rule.compound_id" class="rule-item filter-grid-item">
                            <div>{{ rule.compound_id }}</div>
                            <div>{{ rule.unit }}</div>
                            <div>{{ rule.filter_type }}</div>
                            <div>{{ rule.min }}- <span v-if="rule.max"> {{ rule.max }}</span></div> 
                            <Icon icon="mdi:cancel-bold" width="30" height="30" color="var(--color-primary)" class="icon" @click="removeMetaboliteFilter(rule.compound_id)"/>
                        </div>
                        <div class="rule-item filter-grid-item" v-if="currently_adding_metabolite_filter">
                            <select v-model="metabolite_filter_id" @change="getNconcsForMetabolite(metabolite_filter_id), getUnitsForMetabolite(metabolite_filter_id)">
                                <option selected disabled value="">Choose metabolite</option>
                                <option v-for="metabolite in active_metabolites" :key="metabolite" :value="metabolite">{{ metabolite }}</option>
                            </select>
                            <select v-model="metabolite_filter_unit">
                                <option selected disabled value="">Choose unit</option>
                                <option v-for="unit in metabolite_filter_possible_unit_list" :value="unit">{{ unit }}</option>
                            </select>
                            <select v-model="metabolite_filter_type">
                                <option selected value="in_bounds">INSIDE arbitrary min/max</option>
                                <option value="out_bounds">OUTSIDE arbitrary min/max</option>
                                <option v-if="nconcs && nconcs.filter((s) => s.nconc_unit?.toLowerCase() == metabolite_filter_unit.toLowerCase()).length >= 1" value="in_nconc">INSIDE normal concentration</option>
                                <option v-if="nconcs && nconcs.filter((s) => s.nconc_unit?.toLowerCase() == metabolite_filter_unit.toLowerCase()).length >= 1" value="out_nconc">OUTSIDE normal concentration</option>
                                <option value="visualize">VISUALIZE this range</option>
                            </select>
                            <div>
                                <select v-if="metabolite_filter_type.includes('nconc') && nconcs" v-model="metabolite_filter_nconc">
                                    <option selected :value="null">Choose normal concentration</option>
                                    <option v-for="nconc of nconcs.filter((s) => s.nconc_unit?.toLowerCase() == metabolite_filter_unit.toLowerCase())" :key="nconc.compound_id" :value="nconc">
                                        <span v-if="nconc.nconc_biospecimen">{{nconc.nconc_biospecimen}}</span>
                                        <span v-if="nconc.nconc_sex">-{{nconc.nconc_sex}}</span>
                                        <span v-if="nconc.nconc_age">-{{nconc.nconc_age}}</span>
                                        <span v-if="nconc.nconc_state">-{{nconc.nconc_state}}</span>
                                        <span v-if="nconc.nconc_source">-{{nconc.nconc_source}}</span>
                                        {{nconc.nconc_min}}-<span v-if="nconc.nconc_max">{{ nconc.nconc_max}}</span> <span v-if="nconc.nconc_unit">{{ nconc.nconc_unit }}</span>
                                    </option>
                                </select>
                                <div v-if="!metabolite_filter_type.includes('nconc') || !nconcs" class="filter-minmax">
                                    Min:&nbsp;<input type="number" v-model="metabolite_filter_min">
                                    Max:&nbsp;<input type="number" v-model="metabolite_filter_max">
                                </div>
                            </div>
                            <Icon icon="mdi:tick" width="30" height="30" color="green" class="icon" @click="addMetaboliteFilter"/>
                        </div>
                        <div class="rule-grid-add" id="filter-grid-add" v-if="!currently_adding_metabolite_filter" @click="setAddingFilter">+</div>
                </div>
            </div>
        </div>
        <div class="query-section" v-if="query.query_studies?.length">
            <div class="query-sub-headline">4. Choose phenotype</div>
            <div class="query-phenotypes">
                <div class="query-phenotype-box">
                    <div class="query-phenotype-headline">The following phenotypes are applicable:</div>
                    <div class="span-grid" v-if="!Object.keys(query.query_phenotypes as object).length">No phenotypes were found for this study.</div>
                    <div class="query-phenotype-item" v-for="phenotype in query.query_phenotypes">
                        <div>{{ phenotype.phenotype_id }}</div>
                        <div><span style="font-family: var(--ff-default)">contained in: </span>{{ phenotype.studies.join(', ') }}</div>
                        <div class="phenotype-checkboxes">
                            <div>Include&nbsp;<input type="checkbox" checked :id="`include-${phenotype.phenotype_id}`" 
                                @change="deactivateOtherPhenoCheckboxes('include', phenotype.phenotype_id)"></div>
                            <div>Exclude&nbsp;<input type="checkbox" :id="`exclude-${phenotype.phenotype_id}`" 
                                @change="deactivateOtherPhenoCheckboxes('exclude', phenotype.phenotype_id)"></div>
                            <div>Include, but only some levels&nbsp;<input type="checkbox" :id="`includesome-${phenotype.phenotype_id}`" 
                                @change="deactivateOtherPhenoCheckboxes('includesome', phenotype.phenotype_id)"></div>
                        </div>
                        <div class="query-phenotype-subitem" :id="`subitem-${phenotype.phenotype_id}`" style="display: none;">
                            <div class="pheno-level" v-for="level in phenotype.levels">
                                <div>{{ level }}</div>
                                <div style="font-family: var(--ff-default)">Include&nbsp;
                                    <input type="checkbox" checked :id="`${phenotype.phenotype_id}-${level}`" @change="readjustFilterRule(phenotype.phenotype_id)"/>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
        <div class="buttons" style="margin-top: 1rem;">
            <button :disabled="!checkRequirements()" @click="submitQuery">Submit</button>
            <div v-if="query.query_studies && query.query_studies?.length >= 2">
                <input type="checkbox" v-model="aggregate_multiple"> <span style="font-size: var(--fs-small)">Aggregate based on source ID (experimental)</span>
            </div>
            <VueSpinnerGears v-if="loading" size="24" color="var(--color-primary)"></VueSpinnerGears>
        </div>
        <QueryResults v-if="Object.keys(query.query_results).length"></QueryResults>
        <div class="buttons" v-if="Object.keys(query.query_results).length" style="margin-top: 1rem;">
            <button @click="downloadQueryResults">Download results as CSV</button>
        </div>
    </div>
</template>
<script setup lang="ts">
import { useQueryStore, type ArbitraryObject, type UnitMap } from '@/stores/query';
import { useStudyStore, type StudyData } from '@/stores/studies';
import { useAuthStore } from '@/stores/auth';
import { computed, onMounted, ref, watch } from 'vue';
import { getStudyCompounds, getStudyList, getStudyUnits } from '@/modules/study_module';
import { Icon } from '@iconify/vue';
import { getNconcs, type NormalConcentration, type CompoundData, type MetaboliteFilterRule, executeQuery, type PhenotypeFilterRule, getPhenotypeInformation, queryResultsToCSV } from '@/modules/query_module';
import QueryResults from '@/components/QueryResults.vue';
import { useMessageStore } from '@/stores/message';
import { VueSpinnerGears } from 'vue3-spinners';

const query = useQueryStore();
const studies = useStudyStore();
const auth = useAuthStore();
const msg = useMessageStore();

onMounted(async () => {
    await refreshStudies();
    await refreshCompounds();
    await refreshPhenotypes();
})

const downloadQueryResults = async () => {
    if (!query.query_results) return;
    const potential_blob = await queryResultsToCSV();
    if (potential_blob) {
        const link = document.createElement('a');
        link.href = URL.createObjectURL(potential_blob);
        link.download = "query_results.csv";
        document.body.appendChild(link);
        link.click();
        document.body.removeChild(link);
        URL.revokeObjectURL(link.href);
    }
}

const getInfoboxColor = (key: string, value: any) => {
    switch (key) {
        case 'study_visibility':
            switch (<string>value) {
                case 'private':
                    return 'crimson';
                default:
                    return 'green';
            }
        case 'study_date':
            return 'var(--color-primary)';
        case 'study_specimen':
            switch (<string>value) {
                case 'serum':
                case 'blood':
                case 'plasma':
                    return 'var(--color-blood)';
                case 'urine':
                    return 'var(--color-urine)';
                case 'feces':
                    return 'var(--color-feces)';
                case 'csf':
                    return 'var(--color-csf)';
                case 'other':
                    return 'var(--color-other)';
                case 'multiple':
                    return 'var(--color-multiple)';
                default:
                    return 'var(--color-unknown)';
            }
        case 'study_type':
            return ('var(--color-head)');
    }
}

const formatInfobox = (key: string, value: any) => {
    if (<string>value == 'unknown') {
        return `unknown ${key.replace('study_','')}`;
    }
    if (<string>value == 'gcms') {
        return 'lc-ms'; //ONLY FOR SCREENSHOTS
    }
    if (<string>value == 'lcms') {
        return 'lc-ms';
    }
    return value;
}

const deactivateOtherCheckboxes = (checkbox: string) => {
    for (let property of Object.keys(metabolite_checkboxes.value)) {
        if (property != checkbox) {
            metabolite_checkboxes.value[property as keyof typeof metabolite_checkboxes.value] = false;
        }
    }
}

const refreshStudies = async () => {
    await getStudyList();
    if (studies.studies_owned)
        all_studies.value = studies.studies_owned;
    if (studies.studies_shared)
        all_studies.value = all_studies.value?.concat(studies.studies_shared);
    if (studies.studies_public)
        all_studies.value = all_studies.value?.concat(studies.studies_public);
    await retrieveUnits();
}

const retrieveUnits = async () => {
    query.query_units = [];
    let qu = await getStudyUnits(all_studies.value?.map((st: StudyData) => st.study_id));
    for (const [substudy, units] of Object.entries(qu.body)) {
        if (!query.query_studies?.map((s: StudyData) => s.study_id).includes(substudy)) continue;
        query.query_units.push({study_id: substudy, unit_map: units} as UnitMap)
    }
}

const getUnitsForMetabolite = (metabolite: string): void => {
    metabolite_filter_possible_unit_list.value = query.unitForMetabolite(metabolite);
    if (metabolite_filter_possible_unit_list.value)
        metabolite_filter_unit.value = metabolite_filter_possible_unit_list.value[0];
}


const refreshCompounds = async () => {
    let study_descriptors: string[] | undefined = query.query_studies?.map((st: StudyData) => st.study_id)
    let query_compounds = await getStudyCompounds(study_descriptors);
    if (query_compounds.status == 200) {
        query.query_compounds = Object.keys(query_compounds.body).sort().reduce((acc, k) => ({...acc, [k]: query_compounds.body[k]}), {});
    } 
}

const refreshPhenotypes = async () => {
    query.query_phenotypes = {};
    let study_descriptors: string[] | undefined = query.query_studies?.map((st: StudyData) => st.study_id)
    if (study_descriptors) {
        for (let study of study_descriptors) {
            let query_phenotypes = await getPhenotypeInformation(study);
            if (query_phenotypes) {
                if (!query.query_phenotypes) query.query_phenotypes = {} as ArbitraryObject;
                for (let phenotype in query_phenotypes) {
                    // Equal levels
                    if (query.query_phenotypes[phenotype] && JSON.stringify(query.query_phenotypes[phenotype]['levels']) === JSON.stringify(query_phenotypes[phenotype]))
                        <string[]>query.query_phenotypes[phenotype]['studies'].push(study);
                    // Different levels
                    else if (query.query_phenotypes[phenotype]) {
                        <string[]>(query.query_phenotypes[phenotype]['studies']).push(study);
                        query.query_phenotypes[phenotype]['levels'] = query.query_phenotypes[phenotype]['levels'].concat(query_phenotypes[phenotype]);
                    }
                    // New entry  
                    else query.query_phenotypes[phenotype] = {phenotype_id: phenotype, studies: [study], levels: query_phenotypes[phenotype]};
                }
            }
        }
    }
}

const addtoSelection = async (study: StudyData) => {
    if (query.query_studies && query.query_studies?.includes(study)) {
        return;
    } else {
        query.query_studies?.push(study);
    }
    await retrieveUnits();
}

const showMetaboliteInfo = (compound_key: string): void => {
    metabolite_shown.value = query.query_compounds[compound_key as keyof typeof query.query_compounds];
    if (!metabolite_shown.value || Object.keys(metabolite_shown.value).length == 0) {
        metabolite_shown.value = {compound_name: 'No information for metabolite.'};
    }   
}

const hideMetaboliteInfo = (): void => {
    //metabolite_shown.value = {}; deactivated for paper screenshots
}

const addToQueryCompounds = (compound: string): void => {
    if (query.query_compound_selection.includes(compound)) return;
    query.query_compound_selection.push(compound);
    query.query_compound_selection.sort()
}

const isNumber = (val: any) => typeof val === "number" && val === val;

const addMetaboliteFilter = () => {
    if (!metabolite_filter_id.value || !metabolite_filter_type.value) return;
    let adapted_filter_type = ():string => {
        if (['out_nconc','out_bounds'].includes(metabolite_filter_type.value)) return 'out';
        else if (metabolite_filter_type.value === 'visualize') return 'vis';
        else return 'in';
    }
    let filter_rule: MetaboliteFilterRule = {
       compound_id: metabolite_filter_id.value,
       filter_type: adapted_filter_type(),
       min: 0.0,
       unit: metabolite_filter_unit.value,
    }
    // Set min
    if (metabolite_filter_type.value.includes('nconc') && metabolite_filter_nconc.value?.nconc_min && isNumber(metabolite_filter_nconc.value.nconc_min))
        filter_rule.min = Math.max(0.0,metabolite_filter_nconc.value?.nconc_min);
    else if (metabolite_filter_min.value && !metabolite_filter_type.value.includes('nconc') && isNumber(metabolite_filter_min.value))
        filter_rule.min = Math.max(0.0, metabolite_filter_min.value);

    // Set max
    if (metabolite_filter_max.value && !metabolite_filter_type.value.includes('nconc') && isNumber(metabolite_filter_max.value))
        filter_rule.max = Math.max(0.0,metabolite_filter_max.value);
    else if (metabolite_filter_nconc.value?.nconc_max && metabolite_filter_type.value.includes('nconc') && isNumber(metabolite_filter_nconc.value.nconc_max))
        filter_rule.max = Math.max(0.0, metabolite_filter_nconc.value.nconc_max);

    // Sanity check
    if (!isNumber(filter_rule.min)) return;
    if (filter_rule.max && !isNumber(filter_rule.max)) return;
    if (filter_rule.max && filter_rule.max < filter_rule.min) {
        let temp = filter_rule.max;
        filter_rule.max = filter_rule.min;
        filter_rule.min = temp;
    }

    metabolite_filters.value.push(filter_rule);
    currently_adding_metabolite_filter.value = false;
    metabolite_filter_max.value = null;
    metabolite_filter_min.value = 0.0;
    metabolite_filter_type.value = "in_bounds";
    metabolite_filter_id.value = "";

    metabolite_filter_unit.value = "";
    document.getElementById("filter-grid-add")?.scrollIntoView();
}

const removeMetaboliteFilter = (compound: string) => {
    metabolite_filters.value = metabolite_filters.value.filter((r: MetaboliteFilterRule) => r.compound_id != compound);
}

const checkRequirements = ():boolean => {
    return (
        !!(query.query_studies && query.query_studies.length >=1) && 
        (active_metabolites.value != undefined && active_metabolites.value.length >= 1)
    );
}

const getNconcsForMetabolite = async (compound: string) => {
    nconcs.value = await getNconcs(compound);
}

const setAddingFilter = () => {
    currently_adding_metabolite_filter.value = true;
}

const submitQuery = async () => {
    if (!query.query_studies) return;
    loading.value = true;
    // If all metabolites are retrieved, no metabolite subsetting is required
    let visualizations = metabolite_filters.value.filter((f) => f.filter_type === "vis");
    let actual_filters = metabolite_filters.value.filter((f) => f.filter_type != "vis");
    if (metabolite_checkboxes.value['checkbox_all'])
        query.query_results = await executeQuery(query.query_studies.map((st) => st.study_id), undefined, actual_filters, phenotype_filters.value, visualizations, aggregate_multiple.value);
    // If a portion of metabolites is to be exluded, send all active metabolites
    else if (metabolite_checkboxes.value['checkbox_ex'])
        query.query_results = await executeQuery(query.query_studies.map((st) => st.study_id), <string[]>active_metabolites.value, actual_filters, phenotype_filters.value, visualizations, aggregate_multiple.value);
    // If a subset of metabolites is to be retrieved, simply send only the selection
    else
        query.query_results = await executeQuery(query.query_studies.map((st) => st.study_id), query.query_compound_selection, actual_filters, phenotype_filters.value, visualizations, aggregate_multiple.value);

    loading.value = false;
    query.query_plot_ids = query.query_results["METABOSERV_PLOTS" as keyof typeof query.query_results];
    if (!query.query_plot_ids.histogram) msg.add_message({msg: "Sorry, the histogram could not be drawn - different units were detected for the desired metabolite!", status:400});
    if (!query.query_plot_ids.scatterplot && query.query_compound_selection.length >= 2) msg.add_message({msg: "Sorry, the scatterplot could not be drawn - different units were detected for the desired metabolite(s)!", status:400});
    delete query.query_results["METABOSERV_PLOTS" as keyof typeof query.query_results];
    query.query_phenotype_filters = phenotype_filters.value;
    query.query_active_metabolites = [...<string[]>active_metabolites.value];
    query.query_filters = metabolite_filters.value;
}

const deactivateOtherPhenoCheckboxes = (checkbox: string, phenotype_id: string):void => {
    let include_box = document.getElementById(`include-${phenotype_id}`) as HTMLInputElement;
    let exclude_box = document.getElementById(`exclude-${phenotype_id}`) as HTMLInputElement;
    let includesome_box = document.getElementById(`includesome-${phenotype_id}`) as HTMLInputElement;
    let subitem = document.getElementById(`subitem-${phenotype_id}`) as HTMLElement;
    switch (checkbox) {
        case 'include':
            if (include_box?.checked) {
                exclude_box.checked = false;
                includesome_box.checked = false;
            }
            else {
                include_box.checked = true;
            }
            subitem.style.display = "none";
            phenotype_filters.value = phenotype_filters.value.filter((pf) => pf.phenotype != phenotype_id); // Deletes current phenotype rule
            query.query_phenotype_filters = phenotype_filters.value;
            break;
        case 'exclude':
            if (exclude_box?.checked) {
                include_box.checked = false;
                includesome_box.checked = false;
            }
            else {
                exclude_box.checked = true;
            }
            subitem.style.display = "none";
            phenotype_filters.value = phenotype_filters.value.filter((pf) => pf.phenotype != phenotype_id);
            phenotype_filters.value.push({phenotype: phenotype_id, include: false});
            query.query_phenotype_filters = phenotype_filters.value;
            break;
        case 'includesome':
            if (includesome_box?.checked) {
                exclude_box.checked = false;
                include_box.checked = false;
            }
            else {
                includesome_box.checked = true;
            }
            subitem.style.display = "grid";
            readjustFilterRule(phenotype_id);
            break;
        default:
            return;
    }
}

const readjustFilterRule = (phenotype_id: string) => {
    phenotype_filters.value = phenotype_filters.value.filter((pf) => pf.phenotype != phenotype_id);
    let levels = [] as string[];
    if (query.query_phenotypes)
        for (let level of query.query_phenotypes[phenotype_id].levels) {
            let cb = (document.getElementById(`${phenotype_id}-${level}`) as HTMLInputElement);
            if (cb && cb.checked)
                levels.push(level);
        }
    phenotype_filters.value.push({phenotype: phenotype_id, include: true, included_levels: levels});
    query.query_phenotype_filters = phenotype_filters.value;
}

const box_keys = ref<string[]>(['study_type', 'study_specimen', 'study_date', 'study_visibility']);
const all_studies = ref<StudyData[]|undefined>([]);
const metabolite_checkboxes=ref({checkbox_all: true, checkbox_ex: false, checkbox_sub: false});
const metabolite_shown = ref<CompoundData>({});
const metabolite_filters = ref<MetaboliteFilterRule[]>([]);
const currently_adding_metabolite_filter = ref<boolean>(true);
const active_metabolites = computed(() => {
    if (metabolite_checkboxes.value['checkbox_all']) return Object.keys(query.query_compounds);
    if (metabolite_checkboxes.value['checkbox_ex']) return Object.keys(query.query_compounds).filter(c => !query.query_compound_selection.includes(c));
    if (metabolite_checkboxes.value['checkbox_sub']) return Object.keys(query.query_compounds).filter(c => query.query_compound_selection.includes(c));
});

const metabolite_filter_type = ref("in_bounds");
const metabolite_filter_id = ref("");
const metabolite_filter_max = ref<number|null>(null);
const metabolite_filter_min = ref<number>(0.0);
const metabolite_filter_nconc = ref<NormalConcentration|null>(null);
const metabolite_filter_unit = ref("mmol/L");
const metabolite_filter_possible_unit_list = ref<string[]>([]);
const nconcs = ref<NormalConcentration[]|null>([]);
const loading = ref<boolean>(false);
const aggregate_multiple = ref<boolean>(true);

const phenotype_filters = ref<PhenotypeFilterRule[]>([]);

watch(() => query.query_studies?.length, async() => {
    await refreshCompounds();
    await refreshPhenotypes();
});
watch(() => [auth.jwt, auth.aut], async () => await refreshStudies());

</script>

<style scoped>

.pheno-level {
    display: grid;
    grid-template-columns: subgrid;
    grid-column: 2 / 4;
}

.phenotype-checkboxes {
    display: flex;
    justify-items: center;
    align-items: center;
    font-family: var(--ff-default);
    gap: 2rem;    
}


.query-phenotype-subitem {
    display: grid;
    grid-column: 1 / 4;
    grid-template-columns: subgrid;
}
.query-phenotype-item {
    display: grid;
    grid-column: 1/4;
    font-family: 'Roboto Mono', monospace;
    font-size: 0.85rem;
    grid-template-columns: subgrid;
    padding: 0.5rem;
    accent-color: var(--color-accent);
}

.query-phenotype-item:nth-child(2n) {
    background-color: var(--color-bg-alt);
}
.query-phenotype-box {
    display: grid;
    align-items: baseline;
    grid-template-columns: 1fr 1.5fr 3fr;
    min-height: 5rem;
    border: var(--bd-default);
    box-shadow: var(--sd-default);
    background-color: #fff;
    max-height: 35rem;
    overflow-y: auto;
}

.query-phenotype-headline {
    grid-column: 1 / 4;
    background-color: var(--color-head);
    color: var(--color-bg);
    padding-left: 1rem;
    font-weight: bold;
}

.filter-minmax {
    grid-column: 3/4;
    display: flex;
    align-items: center;
    flex-direction: row;
}

.filter-minmax input {
    max-width: 10ch;
    accent-color: var(--color-accent);
}

select {
    font-family: 'Roboto Mono', monospace;
    font-size: 0.85rem;
    max-width: 50ch;
}

.filter-grid-item {
    padding: 0.5rem;
}

.filter-grid-headline {
    background-color: var(--color-head);
    color: var(--color-bg);
    align-items: center;
    justify-items: baseline;
    padding-left: 0.5rem;
}

.filter-grid {
    background-color: var(--color-bg);
    border: var(--bd-default);
    overflow-y: auto;
    padding: 0;
    padding-bottom: 0.5rem;
    max-height: 40rem;
}

.metabolite-entry {
    cursor:pointer;
}

.metabolite-info {
    margin: auto;
    display: flex;
    flex-direction: column;
}

.query-phenotypes {
    margin: 1rem auto;
    max-width: 100%;
    display: grid;
    grid-template-columns: 0.8fr;
    justify-content: center;
    align-items: baseline;
    column-gap: 2rem;
}

.metabolite-collection {
    width: 100%;
    display: flex;
    flex-direction: column;
    background-color: var(--color-bg);
    font-family: 'Roboto Mono', monospace;
    font-size: 0.85rem;
}

.metabolite-collection > * {
    padding-left: 1rem;
}

.metabolite-collection > *:nth-child(2n) {
    background-color: var(--color-bg-alt);
}

.metabolite-collection > *:hover {
    background-color: var(--color-head);
    color: var(--color-bg);
}

.query-metabolite-all {
    display: flex;
    flex-direction: column;
    overflow-y: auto;
    max-height: 30rem;
    
}
.query-metabolite-info {
    background: var(--color-bg);
    min-height: 20rem;
    border-left: 1px solid var(--color-head);
    border-right: 1px solid var(--color-head);
    display: flex;
    padding: 1rem;
    align-items: center;
    text-align: center;
}

.bold-centered {
    font-weight: bold;
    font-size: var(--fs-default);
}
.query-metabolite-manage {
    grid-column: 1 / 4;
    max-height: 6rem;
    display: flex;
    flex-direction: row;
    flex-wrap: wrap;
    gap: 2rem;
    background-color: var(--color-head);
    color: var(--color-bg);
    padding: 0 1rem;
    align-items: center;
    font-size: var(--fs-small);
    border-bottom: 2px solid var(--color-head);
}

.query-container {
    display: flex;
    justify-items: baseline;
    flex-direction: column;
    min-width: 65%;
    max-width: 100%;
    margin: 5.5rem auto;
}

.query-headline {
    margin-top: 1rem;
    font-size: var(--fs-title);
    text-align: center;
    color: var(--color-head);
    font-weight: bold;
}

.span-grid {
    grid-column: 1 / 4;
    font-size: 0.65rem;
    color: var(--color-info);
    text-align: center;
    background-color: inherit;
}

.query-sub-headline {
    padding-top: 0.5rem;
    font-size: var(--fs-large);
    text-align: center;
    color: var(--color-primary);
    font-weight: bold;
    grid-column: 1 / 3;
}

.query-study-selection {
    display: grid;
    grid-template-columns: 0.5fr 0.3fr;
    justify-content: center;
    column-gap: 2rem;
    margin: 1rem auto;
    max-width: 100%;
}

.query-all-studies {
    min-height: 10rem;
    max-height: 25rem;
    background-color: var(--color-bg);
    overflow-y: auto;
    border: var(--bd-default);
    box-shadow: var(--sd-default);
}
.selection-box-all {
    display: grid;
    grid-template-columns: 0.35fr 0.65fr;
    column-gap: 4rem;
    grid-auto-flow: row;
    justify-content: baseline;
    align-items: center;
    align-content: baseline;
    margin: 1rem;
}

.study-row {
    display: grid;
    grid-template-columns: subgrid;
    font-family: 'Roboto Mono', monospace;
    background-color: var(--color-bg-alt);
    font-size: 0.75rem;
    grid-column: 1 / 4;
    justify-content: baseline;
    align-content: baseline;
    align-items: center;
    cursor: pointer;
    padding: 0.25rem 0;
}

.study-row:nth-child(2n) {
    background-color: var(--color-bg);
}

.study-select-row {
    display: grid;
    grid-template-columns: subgrid;
    font-family: 'Roboto Mono', monospace;
    font-size: 0.75rem;
    grid-column: 1 / 3;
    justify-content: baseline;
    align-content: baseline;
    align-items: center;
    cursor: pointer;
    background-color: var(--color-bg-alt);
}

.study-select-row:nth-child(2n) {
    background-color: var(--color-bg);
}

.info-box {
    border-radius: 8px;
    padding: 0.25rem;
    width: fit-content;
    height: fit-content;
    box-shadow: 2px 2px 2px #000;
}

.selection-box {
    font-family: 'Roboto Mono', monospace;
    font-size: 0.85rem;
    background-color: var(--color-bg);
    margin: 1rem;
    display: grid;
    grid-template-columns: 1fr 48px;
    padding: 0;
}

.query-selected-studies {
    background-color: var(--color-bg);
    min-height: 10rem;
    max-height: 20rem;
    overflow-y: auto;
    border: var(--bd-default);
    display: flex;
    flex-direction: column;
    box-shadow: var(--sd-default);
}

.icon:hover {
    scale: 1.1 1.1;
    cursor: pointer;
}

.query-metabolite-selection {
    margin: 1rem auto;
    display: grid;
    grid-template-columns: 0.8fr;
    justify-content: center;
    align-items: baseline;
    column-gap: 2rem;
}

.query-metabolite-box {
    display: grid;
    min-height: 20rem;
    grid-template-columns: repeat(3, 1fr);
    border: var(--bd-default);
    box-shadow: var(--sd-default);
    background-color: #fff;
    max-height: 35rem;
}

#metabolite-filter-grid {
    grid-template-columns: 1fr 1fr 1fr 1.5fr 0.5fr;
    max-height: 20rem;
}

@media (max-width: 1500px) {

.query-metabolite-selection .query-study-selection .query-phenotypes {
    max-width: 100%;
}

#metabolite-filter-grid select {
    max-width: 20ch;
}

#metabolite-filter-grid input {
    max-width: 6ch;
}


}

</style>
